/*******************************************************************************
                     Computación Paralela 2012 - FaMAF
                      Universidad Nacional de Córdoba

Ejercicio 4 - WTF?
==================
El siguiente programa intenta incrementar un contador que reside en memoria
global una vez por thread (en este caso 1M threads), sin éxito. Qué sucede?

Corrija el problema usando atomics en memoria global, y luego para reducir la
contención sobre device_counter obtenga un subtotal por bloque en memoria
compartida antes de sumar a memoria global.

********************************************************************************/

#include <cuda.h>
#include <cutil.h>
#include <stdio.h>

__device__ uint device_counter;

__global__ void increment() {
    device_counter = device_counter + 1;
}


int main(int argc, char ** argv) {

    uint host_counter = 0;

    CUDA_SAFE_CALL(cudaMemcpyToSymbol(device_counter, &host_counter, sizeof(uint)));

    dim3 block(1024);
    dim3 grid(1024);
    increment<<<grid, block>>>();

    CUT_CHECK_ERROR("Error al lanzar el kernel:");

    CUDA_SAFE_CALL(cudaMemcpyFromSymbol(&host_counter, device_counter, sizeof(uint)));

    printf("%u\n", host_counter);

    return 0;
}
